<?php
namespace App\Controllers\Organization;

use CodeIgniter\API\ResponseTrait;
use App\Controllers\BaseController;

use App\Models\Organization\AccountModel;

class AccountController extends BaseController {
    use ResponseTrait;

    protected $db;
    protected $model;

    public function __construct() {
        $this->db = \Config\Database::connect();
        $this->model = new AccountModel();
    }

    public function index() {            
			$filter = [
				'Parent' => $this->request->getVar('Parent'),
				'AccountName' => $this->request->getVar('AccountName'),
			];

			$rows = $this->model->getAccounts($filter);
			
			if (empty($rows)) {
				return $this->respond([ 'status'  => 'success', 'message' => "no Data.", 'data' => [] ], 200);
			}

			return $this->respond([ 'status' => 'success', 'message'=> "fetch success", 'data' => $rows ], 200);
    }

    public function show($AccountID = null) {
        //$rows = $this->model->where('AccountID', $AccountID)->findAll();
        $row = $this->model->getAccount($AccountID);

        if (empty($row)) {
            return $this->respond([ 'status'  => 'success', 'message' => "no Data.", 'data' => null ], 200);
        }

        return $this->respond([ 'status' => 'success', 'message'=> "fetch success", 'data' => $row ], 200);
    }

    public function delete() {
        try {
            $input = $this->request->getJSON(true);
            $id = $input["AccountID"];
            if (!$id) { return $this->failValidationErrors('ID is required.'); }
            $this->model->delete($id);
            return $this->respondDeleted([ 'status' => 'success', 'message' => "{$id} deleted successfully."]);
        } catch (\Throwable $e) {
            return $this->failServerError('Something went wrong: ' . $e->getMessage());
        }
    }

    public function create() {
        $input = $this->request->getJSON(true);
        try {
            $id = $this->model->insert($input,true);
            return $this->respondCreated([ 'status'  => 'success', 'message' => 'data created successfully', 'data' => $id ], 201);
        } catch (\Throwable $e) {
            return $this->failServerError('Something went wrong: ' . $e->getMessage());
        }
    }

    public function update() {
        $input = $this->request->getJSON(true);
        try {
            $id = $input['AccountID'];
            if (!$id) { return $this->failValidationErrors('ID is required.'); }
            $this->model->update($id, $input);
            return $this->respondCreated([ 'status'  => 'success', 'message' => 'data updated successfully', 'data' => $id ], 201);
        } catch (\Throwable $e) {
            return $this->failServerError('Something went wrong: ' . $e->getMessage());
        }
    }
}
